#include "communication.h"
#include <vector>
#include <utility>
#include <cstdio>

int main() {
	int N, M;
	scanf("%d %d", &N, &M);

	std::vector< std::pair<int, int> > E(M);
	for(int i = 1; i <= M; i++) {
		int a, b;
		scanf("%d %d", &a, &b);
		E[i-1].first = a;
		E[i-1].second = b;
	}

	std::vector<int> result = find_num_critical(N, E);

	printf("[");
	for(int i = 0; i < (int)result.size(); i++) {
		if(0 < i) printf(", ");
		printf("%d", result[i]);
	}
	printf("]\n");

	return 0;
}
